
Object subclass: #Client
  instanceVariableNames: 
    ' name phones '
  classVariableNames: ''
  poolDictionaries: ''
  categories: #( 'JOOP' )

!

Object subclass: #LayoutManager
  instanceVariableNames: 
    ' sectionNames sections activeSections fixups '
  classVariableNames: ''
  poolDictionaries: ''
  categories: #( 'JOOP' )

!

Object subclass: #LayoutSection
  instanceVariableNames: 
    ' name stream offset elementType elementSize elementCount streamSize byteSize beginPosition '
  classVariableNames: ''
  poolDictionaries: ''
  categories: #( 'JOOP' )

!

Object subclass: #Phone
  instanceVariableNames: 
    ' areaCode cityCode local '
  classVariableNames: ''
  poolDictionaries: ''
  categories: #( 'JOOP' )

!


!CodeFiler forClass: Client class !
  
new
    ^super new initialize! !

(CodeFiler organizerFor: Client class) reorganizeFrom: #(
('instance creation' new )) !

!CodeFiler forClass: Client class !

example1
    "Client example1"
    ^Client new
        name: 'Tim';
        addPhone: (Phone from: '613-555-1212');
        addPhone: (Phone from: '613-555-4552');
        addPhone: (Phone from: '613-555-0022')! !

(CodeFiler organizerFor: Client class) reorganizeFrom: #(
('examples' example1 )) !


!CodeFiler forClass: Client !
  
initialize
    self name: 'Unknown'.
    phones := OrderedCollection new! !

(CodeFiler organizerFor: Client) reorganizeFrom: #(
('initializing' initialize )) !

!CodeFiler forClass: Client !
  
name: aString
    name := aString!
 
name
    ^name!

phones
    ^phones! !

(CodeFiler organizerFor: Client) reorganizeFrom: #(
('get/set' phones name: name )) !

!CodeFiler forClass: Client !
   
addPhone: aPhone
    self phones add: aPhone! !

(CodeFiler organizerFor: Client) reorganizeFrom: #(
('adding' addPhone: )) !

!CodeFiler forClass: Client !
  
printOn: aStream
    super printOn: aStream.
    aStream nextPutAll: ' called '.
    self name printOn: aStream! !

(CodeFiler organizerFor: Client) reorganizeFrom: #(
('printing' printOn: )) !
CodeFiler setCommentFor: Client to: ''!


!CodeFiler forClass: LayoutManager class !

new
    ^super new initialize! !

(CodeFiler organizerFor: LayoutManager class) reorganizeFrom: #(
('instance creation' new )) !

!CodeFiler forClass: LayoutManager class !
  
exampleLayout2: fileName
    "LayoutManager exampleLayout2: 'c:\poof\junk'"

    | manager |
    manager := LayoutManager new
        layout: #(header clients names phones).
    manager for: #header do: [
        manager
            emitReference: #clients;
            emitSize: #clients;
            emitReference: #names;
            emitSize: #names;
            emitReference: #phones;
            emitSize: #phones].
    self exampleClients do: [:client |
        manager for: #clients do: [
            manager
                emitReferenceToNext: #names;
                emitReferenceToNext: #phones;
                emitLong: client phones size.
            manager for: #names do: [
                manager emitString: client name].
            client phones do: [:phone |
                manager for: #phones do: [
                    manager
                        emitShort: phone areaCode;
                        emitShort: phone cityCode;
                        emitShort: phone local]]]].
    manager dump: fileName!
 
exampleClients
    "LayoutManager exampleClients"

    | manager clients client clientCount |
    clientCount := 0.
    clients := #(2 1 3) collect: [:phoneCount |
        clientCount := clientCount + 1.
        client := Client new
            name: 'client', clientCount printString.
        1 to: phoneCount do: [:phoneIndex |
            client addPhone: (Phone
                from: '613-555-000', phoneIndex printString)].
        client].
    ^clients!

exampleLayout1: fileName
    "LayoutManager exampleLayout1: 'c:\poof\junk'"

    | manager |
    manager := LayoutManager new.
    manager
        layout: #(header clients names phones);
        begin: #header;
            emitReference: #clients;
            emitSize: #clients;
            emitReference: #names;
            emitSize: #names;
            emitReference: #phones;
            emitSize: #phones;
        end.
    self exampleClients do: [:client |
        manager
            begin: #clients;
                emitReferenceToNext: #names;
                emitReferenceToNext: #phones;
                emitLong: client phones size;
                begin: #names;
                    emitString: client name;
                end.
                client phones do: [:phone |
                    manager
                        begin: #phones;
                            emitShort: phone areaCode;
                            emitShort: phone cityCode;
                            emitShort: phone local;
                        end].
        manager
            end].
    manager dump: fileName! !

(CodeFiler organizerFor: LayoutManager class) reorganizeFrom: #(
('examples' exampleLayout2: exampleLayout1: exampleClients )) !


!CodeFiler forClass: LayoutManager !
  
initialize
    activeSections := OrderedCollection new.
    fixups := OrderedCollection new.! !

(CodeFiler organizerFor: LayoutManager) reorganizeFrom: #(
('initializing' initialize )) !

!CodeFiler forClass: LayoutManager !

for: sectionName do: aBlock
    self begin: sectionName.
    aBlock value.
    self end!
 
layout: anArray
    sectionNames := anArray.
    sections := IdentityDictionary new.
    sectionNames do: [:name |
        sections
            at: name
            put: (LayoutSection new name: name)].
! !

(CodeFiler organizerFor: LayoutManager) reorganizeFrom: #(
('layout/grouping' for:do: layout: )) !

!CodeFiler forClass: LayoutManager !

begin: sectionName
    activeSections add: (sections at: sectionName).
    self activeSection begin!
  
end
    self activeSection end.
    activeSections removeLast.! !

(CodeFiler organizerFor: LayoutManager) reorganizeFrom: #(
('layout/grouping support' begin: end )) !

!CodeFiler forClass: LayoutManager !
   
emitReferenceToNext: sectionName
    self
        emitReferenceTo: sectionName
        at: self activePosition!
  
emitByte: anInteger
    self activeStream nextBytePut: anInteger!
  
emitLong: anInteger
    self activeStream nextULongPut: anInteger!
 
emitString: aString
    "Output with \0 terminator."
    self activeStream
        putBytesFrom: aString;
        nextBytePut: 0!
   
emitSize: sectionName
    self emitFixSectionSize: sectionName.
    self emitLong: 0!
 
emitReference: sectionName
    self
        emitReferenceTo: sectionName
        at: 0!
  
emitShort: anInteger
    self activeStream nextUShortPut: anInteger! !

(CodeFiler organizerFor: LayoutManager) reorganizeFrom: #(
('emitting' emitReferenceToNext: emitLong: emitByte: emitString: emitSize: emitReference: emitShort: )) !

!CodeFiler forClass: LayoutManager !

activeStream
    ^self activeSection stream!
   
activePosition
    ^self activeStream position!

emitReferenceTo: sectionName at: sectionOffset
    self emitFixSectionReferenceTo: sectionName at: sectionOffset.
    self emitLong: 0!
   
activeSection
    ^activeSections last! !

(CodeFiler organizerFor: LayoutManager) reorganizeFrom: #(
('emitting support' activeStream activePosition emitReferenceTo:at: activeSection )) !

!CodeFiler forClass: LayoutManager !

referenceFixupMessageTo: section at: sectionOffset
    ^Message
        receiver: self activeSection
        selector: #at:putRelocatedOffset:in:
        arguments: (Array
            with: self activePosition
            with: sectionOffset
            with: section)!

emitFixSectionReferenceTo: sectionName at: sectionOffset
    | section |
    section := sections at: sectionName.
    fixups add: (self referenceFixupMessageTo: section at: sectionOffset)!
 
sizeFixupMessageTo: section
    ^Message
        receiver: self activeSection
        selector: #at:putSizeOf:
        arguments: (Array
            with: self activePosition
            with: section)!

emitFixSectionSize: sectionName
    | section |
    section := sections at: sectionName.
    fixups add: (self sizeFixupMessageTo: section).! !

(CodeFiler organizerFor: LayoutManager) reorganizeFrom: #(
('fixups' referenceFixupMessageTo:at: emitFixSectionReferenceTo:at: sizeFixupMessageTo: emitFixSectionSize: )) !

!CodeFiler forClass: LayoutManager !
  
dump: fileName
    self
        computeSectionOffsets;
        executeFixups;
        appendSectionsInto: fileName! !

(CodeFiler organizerFor: LayoutManager) reorganizeFrom: #(
('dumping' dump: )) !

!CodeFiler forClass: LayoutManager !
  
executeFixups
     fixups do: [:message | message perform]!

computeSectionOffsets
    "Compute offset for each section name; use the section order."
    sections inject: 0 into: [:offset :section |
        section offset: offset.
        offset + section streamSize]!
 
appendSectionsInto: fileName
    | stream section |
    stream := File pathName: fileName.
    sectionNames do: [:name |
        section := sections at: name.
        stream nextPutAll: section contents].
    stream close! !

(CodeFiler organizerFor: LayoutManager) reorganizeFrom: #(
('dumping support' executeFixups appendSectionsInto: computeSectionOffsets )) !
CodeFiler setCommentFor: LayoutManager to: ''!


!CodeFiler forClass: LayoutSection class !
   
new
    ^super new initialize! !

(CodeFiler organizerFor: LayoutSection class) reorganizeFrom: #(
('instance creation' new )) !


!CodeFiler forClass: LayoutSection !
  
initialize
    self
        name: '';
        stream: (WriteStream on: (String new: 1000));
        offset: 0.
    elementType := #unknownSize.
    elementSize := 0.
    elementCount := 0.
    streamSize := 0
! !

(CodeFiler organizerFor: LayoutSection) reorganizeFrom: #(
('initializing' initialize )) !

!CodeFiler forClass: LayoutSection !

elementSize
    ^elementSize!
  
stream: aStream
    stream := aStream!
 
name
    ^name!

offset: anInteger
    offset := anInteger!
 
stream
    ^stream!

streamSize
    ^streamSize!

offset
    ^offset!

elementCount
    ^elementCount!

name: aString
    name := aString! !

(CodeFiler organizerFor: LayoutSection) reorganizeFrom: #(
('get/set' elementSize stream: name offset: stream streamSize offset elementCount name: )) !

!CodeFiler forClass: LayoutSection !
   
reviseElementSize
    | endPosition size |
    elementType == #varyingSize ifTrue: [
        ^self].
    endPosition := self stream position.
    size := endPosition - beginPosition.
    elementType == #unknownSize ifTrue: [
        elementType := #fixedSize.
        elementSize := size.
        ^self].
    "Default: elementType == #fixedSize"
    self elementSize = size ifTrue: [^self].
    elementType := #varyingSize
!
   
begin
    beginPosition := self stream position!
   
end
    self reviseElementSize.
    elementCount := elementCount + 1.
    streamSize := self stream position
! !

(CodeFiler organizerFor: LayoutSection) reorganizeFrom: #(
('grouping' reviseElementSize begin end )) !

!CodeFiler forClass: LayoutSection !

contents
    ^self stream
        position: self streamSize;
        contents
!
 
hasFixedSizeElements
    ^elementType ~~ #varyingSize
! !

(CodeFiler organizerFor: LayoutSection) reorganizeFrom: #(
('queries' contents hasFixedSizeElements )) !

!CodeFiler forClass: LayoutSection !

at: position putRelocatedOffset: amount in: section
    self stream
        position: position;
        nextULongPut: section offset + amount!
   
at: position putSizeOf: section
    section hasFixedSizeElements ifFalse: [
        self error: 'section elements not fixed size'].
    self stream
        position: position;
        nextULongPut: section elementCount! !

(CodeFiler organizerFor: LayoutSection) reorganizeFrom: #(
('fixup choices' at:putRelocatedOffset:in: at:putSizeOf: )) !

!CodeFiler forClass: LayoutSection !
 
printOn: aStream
    aStream nextPutAll: 'section '.
    self name printOn: aStream! !

(CodeFiler organizerFor: LayoutSection) reorganizeFrom: #(
('printing' printOn: )) !
CodeFiler setCommentFor: LayoutSection to: ''!


!CodeFiler forClass: Phone class !
   
from: aString
    "Doesn't perform error checking."
    ^self new
        areaCode: (aString copyFrom: 1 to: 3) asInteger;
        cityCode: (aString copyFrom: 5 to: 7) asInteger;
        local: (aString copyFrom: 9 to: 12) asInteger! !

(CodeFiler organizerFor: Phone class) reorganizeFrom: #(
('instance creation' from: )) !

!CodeFiler forClass: Phone class !

example1
    "Phone example1"
    ^Phone from: '613-555-0012'! !

(CodeFiler organizerFor: Phone class) reorganizeFrom: #(
('examples' example1 )) !


!CodeFiler forClass: Phone !
 
cityCode: aNumber
    cityCode := aNumber!
 
cityCode
    ^cityCode!

areaCode: aString
    areaCode := aString!
 
local
    ^local!
  
local: aNumber
    local := aNumber!
   
areaCode
    ^areaCode! !

(CodeFiler organizerFor: Phone) reorganizeFrom: #(
('get/set' areaCode: local areaCode local: cityCode: cityCode )) !

!CodeFiler forClass: Phone !

pad: integer to: size
    | string |
    string := integer printString.
    string size >= size ifTrue: [^string].
    ^((String new: size - string size)
        atAllPut: $0), string!
   
printOn: aStream
    aStream
        nextPutAll: '(';
        nextPutAll: (self pad: self areaCode to: 3);
        nextPutAll: ')-';
        nextPutAll: (self pad: self cityCode to: 3);
        nextPutAll: '-';
        nextPutAll: (self pad: self local to: 4)! !

(CodeFiler organizerFor: Phone) reorganizeFrom: #(
('printing' pad:to: printOn: )) !
CodeFiler setCommentFor: Phone to: ''!
